# Colophon

[Michael Hucka](https://www.cds.caltech.edu/~mhucka/) wrote the Boffo documentation using the [Sphinx](https://www.sphinx-doc.org) document generator together with [MyST-flavored Markdown](https://myst-parser.readthedocs.io/en/latest/). The theme is the [Material theme for Sphinx](https://bashtage.github.io/sphinx-material/), with light customizations such as the use of Google's [Atkinson Hyperlegible](https://fonts.google.com/specimen/Atkinson+Hyperlegible) font. A [GitHub Action](https://github.com/caltechlibrary/boffo/blob/main/.github/workflows/build-sphinx.yml) takes care of creating the formatted version of the documentation and hosting it on GitHub.io at https://caltechlibrary.github.io/boffo. The formatted output can also be produced manually using commands implemented in the `Makefile` located in the [`docs/`](https://github.com/caltechlibrary/boffo/tree/main/docs) subdirectory of the Boffo source code repository.

The [vector artwork](https://thenounproject.com/icon/barcode-5653940/) used as a starting point for the logo for this project was created by [Sunarto Hamizan](https://thenounproject.com/sunarto_hamizan/)  It is licensed under the Creative Commons [Attribution 3.0 Unported](https://creativecommons.org/licenses/by/3.0/deed.en) license.

The spinner used in some HTML dialogs shown by Boffo came from [SVG Spinners (CSS & SMIL)](https://github.com/n3r4zzurr0/svg-spinners) by [Utkarsh Verma](https://github.com/n3r4zzurr0). The code was copied on 2023-08-01 and is licensed under the [MIT license](https://github.com/n3r4zzurr0/svg-spinners/blob/main/LICENSE) by its author.
