# Glossary

A glossary of common terms used in Boffo.

```{glossary}
API
    API stands for _application programming interface_. An API is an
    interface through which interactions between software can take place. It
    is an approach for software systems to communicate with each other.

Barcode
    In the context of Boffo, a barcode is a unique identifier assigned to
    an item in FOLIO.

Boffo
    Boffo stands for _**B**arc**o**des **f**rom **FO**LIO_, a program written
    in Google Apps Script that provides a function for
    [Google Sheets](https://www.google.com/sheets/about/) to look
    up item barcodes in FOLIO.

Field
    A location within a _record_ where a specific kind of information is
    stored. Sometimes called "attributes" or "slots" of a record or data
    object. A record will typically have many fields, and each field will
    store a value that describes a different facet of the thing
    represented by the record.

FOLIO
    [FOLIO](https://www.folio.org) stands for _Future Of Libraries Is OPEN_.
    It is an open-source library services platform.

Google Apps Script
    [Google Apps Script](https://www.google.com/script/start/) is a
    programming language and development environment that makes it possible
    to add functionality to Google Sheets.

Google Sheet
    A [Google Sheet](https://www.google.com/sheets/about/) is an online
    spreadsheet environment provided by Google.

Item
    In FOLIO, an _item_ refers to a single physical or electronic object that
    can be circulated to patrons. This could be a book, a journal issue, an
    object such as a digital tablet, and so on.

    Sometimes _item_ is short for _item record_, which in FOLIO is a digital
    database record that contains information needed to identify and track a
    single item. The fields in this digital record include barcode,
    availability, and material type.

LSP
    Library Services Platform. A digital system for managing items
    maintained in a library.

PAT
    PAT stands for _personal access token_. A PAT is string of characters
    used to authenticate a user when accessing a network service; it is a
    alternative to authentication via account+password combinations.

Record
    Information stored in a structured manner in a software system. In FOLIO,
    an _item record_ is the electronic data object that contains information
    about an _item_.
```
