# Installation

[Installing Boffo from the Google Marketplace](#using-google-marketplace) is the simplest way to get Boffo, but it is currently only available as an "internal" Google Workspace add-on limited to Caltech Library staff. Users who are not members of the Caltech Library staff will have to use one of the [alternate installation methods described below](#directly-from-source) to get it either from the public Google Apps Script Project or the GitHub repository.


## Using Google Marketplace

When you install Boffo from the Google Marketplace, the version of Boffo you get will remain fixed, even if new versions of Boffo become available, until you uninstall and reinstall the Boffo add-on. Consequently, the instructions below cover two cases: [installing Boffo for the first time](#installing-boffo-for-the-first-time), and [reinstalling Boffo](#reinstalling-boffo) to get a new version.


### Installing Boffo for the first time

To install Boffo, look for the _Extensions_ menu at the top of your Google sheet, click on it, then click on the item _Get add-ons_ from the _Add-ons_ submenu:

<figure>
<img class="shadow" width="800px" src="_static/media/google-sheet-extension-menu-add-ons.png">
</figure>

In the Google Workspace Marketplace panel that is shown next, click on the button titled _Internal apps_ near the top:

<figure>
<img class="shadow" width="800px" src="_static/media/google-marketplace-panel.png">
</figure>

This will change the panel to show apps available for the Caltech Library staff. Boffo should be visible there. Click on the item for Boffo,

<figure>
<img class="shadow" width="800px" src="_static/media/boffo-in-google-marketplace.png">
</figure>

which will make the Google panel show more details about Boffo and a blue _Install_ button:

<figure>
<img class="shadow" width="800px" src="_static/media/boffo-installation-button.png">
</figure>

Click on the _Install_ button. Google will show you several dialogs asking for your permission to install Boffo. Accept and allow the installation, then close the Google Marketplace panel.

**Note**: after you install Boffo as an add-on in a Google Sheet, Google will show a dialog titled "Boffo has been installed!" that looks like this:

<figure>
<img class="shadow" width="800px" src="_static/media/google-screen-after-boffo-installation.png">
</figure>

This dialog states that Boffo has been installed under a menu titled _Add-ons_, but **that is incorrect**. In fact, Google installs it in a menu titled _Extensions_. Please **ignore the instructions to look for an _Add-ons_ menu**. This pop-up is automatically generated by Google's system and not under the control of Boffo, and we can't change it.

### Reinstalling Boffo

If you have already installed Boffo in your Google Spreadsheets, and want to update Boffo to the latest version, you will need to uninstall it and reinstall it. To uninstall Boffo, first look for the _Extensions_ menu at the top of your Google sheet, click on it, then click on the item _Manage add-ons_ from the _Add-ons_ submenu:

<figure>
<img class="shadow" width="800px" src="_static/media/google-sheet-extensions-manage.png">
</figure>

In the Google workspace dialog that pop-ups, click on the 3 dots in the upper right corner of the Boffo icon:

<figure>
<img class="shadow" width="400px" src="_static/media/google-marketplace-boffo-3-dots.png">
</figure>

In the pop-up menu that you get from clicking the 3 dots, select _Uninstall_:

<figure>
<img class="shadow" width="600px" src="_static/media/google-marketplace-boffo-uninstall.png">
</figure>

You'll be asked to confirm the uninstallation in yet another dialog; click on the button for _UNINSTALL APP_ in that dialog:

<figure>
<img class="shadow" width="340px" src="_static/media/google-marketplace-confirm-uninstall.png">
</figure>

When that dialog goes away, close the Google Workspace Marketplace dialog, and now follow [the steps described above to install Boffo](#installing-boffo-for-the-first-time) as if for the first time.


## Directly from source

If you are not at Caltech, you will not be able find Boffo in the Google Marketplace for add-ons. Instead, you will have to install the code from the source files in some way. The following subsections describe two possible methods.

### Copying the Google Apps Script project

This approach does not require the use of command-line tools, but it does require some patience and care because some of the steps below are quite unintuitive.

1. (Optional, but recommended for your sanity.) Create a folder in your Google Drive where you will put the Boffo project files that will be created in the following steps. For the purposes of this documentation, let's assume that this folder is named "Boffo example".
2. Go to the [public folder for Boffo in Google Drive](https://drive.google.com/drive/folders/1PJErJ2ggFqT5H7pQkYr0wrpnf6YorHc-?usp=share_link). It should look more or less like what is shown in the screenshot below.<p align="center"><img width="800px" src="_static/media/boffo-google-drive-folder.png"></p>
3. Right-click over the apps script project named "Boffo (public copy)" and select _Make a copy_ from the contextual menu that pops up.<p align="center"><img width="800px" src="_static/media/google-drive-make-copy.jpg"></p>
4. Go to the location where the copy ended up (usually the top level of your Google Drive) and look for the newly-created apps script project named "Copy of Boffo (public copy)". Right-click on it, and select _Move to_ from the contextual menu that pops-up.<p align="center"><img width="800px" src="_static/media/google-drive-move.png"></p>
5. From the move dialog, select the destination (in this example, the folder named "Boffo example" suggested in step #1 above).<p align="center"><img width="800px" src="_static/media/google-drive-move-destination.png"></p>
6. Navigate to the destination folder where you put it in your Google Drive.
7. (Optional, but why not?) Rename the project file "Copy of Boffo (public copy)" to something less annoying, such as just "Boffo".<p align="center"><img width="800px" src="_static/media/google-drive-rename.png"></p>
8. Create a spreadsheet in the folder next to the "Boffo" apps script project. For the purposes of this documentation, assume this spreadsheet is cleverly named "Example spreadsheet".<p align="center"><img width="800px" src="_static/media/google-drive-example-spreadsheet.png"></p>
9. Double-click on the apps script project (not the spreadsheet!). It should look more or less like the screenshot below.<p align="center"><img width="800px" src="_static/media/gas-editor.png"></p>
10. Click on the blue _Deploy_ button at the top of the page, and select _Test deployments_ from the pull-down menu.<p align="center"><img width="800px" src="_static/media/gas-editor-deployments.png"></p>
11. In dialog that opens next, note the list in the left-hand sidebar shows the item titled "Google Workspace Add-on" as the default. This is the wrong deployment to use for our purposes.<p align="center"><img width="800px" src="_static/media/gas-editor-deployments-wrong-kind.png"></p>
12. Changing the deployment takes two steps. Click the gear icon next to _Select type_ and a pop-up menu will be shown. In this pop-up, you will initially find a check-mark next to the item "Google Workspace Add-on". Select it to _uncheck_ that item. The pop-up will disappear; click on the gear icon a second time, and now select the item titled "Editor Add-on". You should end up with the configuration shown in the screenshot below.<p align="center"><img width="800px" src="_static/media/gas-editor-deployments-right-kind.png"></p>
13. With the configuration changed to "Editor Add-on", click on the button _Create new test_,<p align="center"><img width="800px" src="_static/media/gas-editor-create-test.png"></p>
14. In the dialog that pops up, click on the up arrow icon in the 3rd field (where it initially shows "No document selected").<p align="center"><img width="800px" src="_static/media/gas-editor-select-test-document.png"></p>
15. In the Google Drive selection dialog that is shown next, select the spreadsheet created in step #8 above. and click the blue _Insert_ button in the selection dialog.<p align="center"><img width="800px" src="_static/media/gas-editor-select-spreadsheet.png"></p>
16. The selection dialog will close, and back in the test deployments dialog, click the blue _Save test_ button.<p align="center"><img width="800px" src="_static/media/gas-editor-save-test.png"></p>
17. We're not done yet! The deployments dialog will change, and now will look like the screenshot below. Click the circle next on the line with the name of the spreadsheet you selected.<p align="center"><img width="800px" src="_static/media/gas-editor-click-radio-box.png"></p>
18. Now click on the blue word _Execute_ which will become active as a result of clicking the circle in the previous step.<p align="center"><img width="800px" src="_static/media/gas-editor-click-execute.png"></p>
19. In an exciting development, the deployment dialog will close and your spreadsheet will open in a new tab or window in your browser. Click on the Extensions menubar item …<p align="center"><img width="800px" src="_static/media/gas-editor-spreadsheet.png"></p>
20. … and here, finally, Boffo's menu will be available in your spreadsheet. And it took only 20 steps to get to this point. Easy, wasn't it?<p align="center"><img width="800px" src="_static/media/gas-editor-boffo-installed.png"></p>


### Using `clasp` to push source files to a GAS project

If you are comfortable with using command-line tools and GitHub, and perhaps want to change Boffo or use it as a starting point for other projects, you can follow the process described next.

1. Clone the [GitHub project for Boffo](https://github.com/caltechlibrary/boffo) to a local directory on your computer, if you have not already done so.
2. Install the command-line utility [`clasp`](https://github.com/google/clasp) if you do not already have it. It lets you maintain your Google Apps Script project files in GitHub and edit them locally, and push them from your local computer to a Google Apps Script project.
3. Create a new Google Apps Script project in your Google Drive.
4. In the Apps Script project interface for this newly-created project, click on the gear icon in the left-hand column.<p align="center"><img width="800px" src="_static/media/new-project.png"></p>
5. From the project settings page, copy the Script ID.<p align="center"><img width="800px" src="_static/media/copy-script-id.png"></p>
6. In your local clone of the Boffo repository, open the file `.clasp.json` in a text editor, and change the value of the field `scriptId` to the value you copied in step #5. For example, if the value you copied was `1hio_6Izyd4908yE4rRy9wUjyIuh0z3jtxy2bb_zBPy9YtPVC6Bh-fv7`, you would change the contents of `.clasp.json` to be
    ```json
    {"scriptId": "1hio_6Izyd4908yE4rRy9wUjyIuh0z3jtxy2bb_zBPy9YtPVC6Bh-fv7"}
    ```
7. Now run `clasp push` to push the Boffo source files to the (empty, freshly-created) Google Apps Script project:
    ```sh
    clasp push
    ```
    Google will ask you to authorize the transfer. Follow the directions to do so.

After this process, you should end up with a copy of the Boffo source files in your Google Apps Project. From there, you can edit the application as well as deploy the new version in your spreadsheets by following a process similar to the one described in the previous section.
