# Usage

Once installed as an Add-on on a Google Sheet, Boffo will present itself as a menu item in the _Extensions_ menu across the top of the sheet. Selecting the _Boffo_ item in the _Extensions_ menu will present several items in a submenu:

<figure>
<img class="shadow border" width="550px" src="_static/media/boffo-menu-items.png">
<figcaption>Boffo's menu can be found in the <em>Extensions</em> menu item in Google Sheets.
</figcaption>
</figure>

## Look up barcodes

Boffo's main function is _Look up barcodes in FOLIO_ and its use is very simple:
1. Select some item barcodes in your Google spreadsheet
2. Pull down the _Extensions_ menu
3. Select _Look up barcodes in FOLIO_ from the Boffo menu

<figure>
<img class="shadow border" width="800px" src="_static/media/invoking-look-up-barcodes.png">
<figcaption>Select some barcodes in your spreadsheet and select the <em>Look up barcodes in FOLIO</em> menu item.
</figcaption>
</figure>

Boffo will create a new sheet titled "Item Data" in the spreadsheet where you ran it, then add the results of the item lookups to the new sheet.

<figure>
<img class="shadow border" width="90%" src="_static/media/sample-output.png">
<figcaption>Boffo creates a new sheet in the same spreadsheet with the results of the lookup.</figcaption>
</figure>

If this is the first time you've used Boffo, it will first request your FOLIO account login and password in order to ask FOLIO for a token to use the network services. Boffo will store that token (and _not_ your login or password), then proceed to look up the items whose barcodes are highlighted in the sheet. On subsequent invocations, Boffo will not ask you for FOLIO credentials unless something happens to make the token invalid (in which case, Boffo will ask you for the credentials again and generate a new token).


## Search by call numbers

Another feature of Boffo is its ability to retrieve all item records at a given location given a range of call numbers. You do not first need to select any barcodes from the spreadsheet to run this command. Simply pull down the Boffo menu and select _Find items in call number range_:

<figure>
<img class="shadow border" width="550px" src="_static/media/menu-item-find-by-call-numbers.png">
</figure>

Boffo will then show a dialog box that looks like this:

<figure>
<img width="95%" src="_static/media/call-number-dialog.png">
</figure>

The dialog asks for three pieces of information: the starting and ending call numbers, and a location. The call numbers must be typed (or copy-pasted) into the text fields, while the location must be chosen from a pull-down menu of available values that is generated by asking the FOLIO server for all known locations.

After filling in the values and choosing a location, click the <span class="button color-primary">Submit</span> button to run the search. Boffo will create a new sheet titled "Item Data" in the spreadsheet where you ran it, and populate the sheet with item records using the same format and set of record fields as the  _Look up barcodes in FOLIO_ command.

Care must be taken when searching by call numbers. It is easy to accidentally add or omit spaces or mistype other parts of call numbers; moreover, the database itself may have inconsistencies or errors in the values stored. To help with this problem, Boffo tries to be flexible: if a given call number does not yield a match, Boffo tries to look up a few alternatives it creates by inserting or removing spaces at strategic places in the given call number.


## Select record fields

In the output sheet, Boffo will create a column for each data field to be shown for item records. You  can change the set of fields by using the option _Select record fields to show_:

<figure>
<img class="shadow border" width="550px" src="_static/media/menu-item-choose-fields.png">
</figure>

This will cause Boffo to show a dialog in which there will be a scrollable list of record fields and checkboxes for each one:

<figure>
<img class="shadow" width="350px" src="_static/media/boffo-select-fields-dialog.png">
<figcaption>Dialog for selecting which item record fields Boffo should include in the output sheet.
</figcaption>
</figure>

Select the desired fields and/or unselect undesired fields, and click the <span class="button color-primary">Submit</span> button to save the selections. The next time Boffo does a barcode lookup, it will show the selected fields in the results sheet.


## Reset FOLIO credentials

If you ever want to change the login that you use to access FOLIO services with Boffo, you can do so by selecting the _Set FOLIO credentials_ item from Boffo's menu:

<figure>
<img class="shadow border" width="550px" src="_static/media/menu-item-set-folio-credentials.png">
</figure>

This will make Boffo bring up the same FOLIO information and account details form that it used to ask you for your login and password the first time:

<figure>
<img width="95%" src="_static/media/folio-credentials-form.png">
<figcaption>The form to reset your FOLIO credentials. (Note: this screenshot shows blank values for all the fields, but for Caltech Library staff who install Boffo as an internal add-on from the Google Marketplace, the values of the FOLIO URL and tenant id will be prefilled with the correct values and you will only need to enter the user name and password.)
</figcaption>
</figure>


## Clear FOLIO token

If you'd like to reset your FOLIO API token deliberately, you can do so by selecting the menu item _Clear FOLIO token_:

<figure>
<img class="shadow border" width="550px" src="_static/media/menu-item-clear-token.png">
<figcaption>The menu item to unset/clear your current FOLIO token.
</figcaption>
</figure>

This Will remove the stored token, and the next time you use the _Look up barcodes in FOLIO_ menu item (or you use the _Set FOLIO credentials_ menu item), Boffo will ask you for your credentials again and then regenerate a new token.


## Get info about Boffo

The _About Boffo_ menu item can be used to find out more about Boffo:

<figure>
<img class="shadow border" width="550px" src="_static/media/menu-item-about-boffo.png">
</figure>

Perhaps the most useful part of the information dialog that is shown by the _About Boffo_ command is Boffo's version number on the second line:

<figure>
<img width="95%" src="_static/media/about-boffo.png">
<figcaption>The information box shown by the <em>About Boffo</em> menu item.
</figcaption>
</figure>


## Get help and report issues

The last item in the Boffo menu is _Help_. The contents are automatically generated by Google's Add-ons framework.  Included in this information dialog is a link that lets you report issues.

<figure>
<img width="95%" src="_static/media/boffo-help.png">
</figure>
